diff -ruN uppsrc/ide/LayDes/laydes.cpp uppsrc/ide/LayDes/laydes.cpp
--- uppsrc/ide/LayDes/laydes.cpp	2013-05-25 23:14:35 +0400
+++ uppsrc/ide/LayDes/laydes.cpp	2013-08-13 11:30:03 +0400
@@ -1252,6 +1252,22 @@
 	ReloadItems();
 }
 
+void LayDes::SortItems()
+{
+	SaveState();
+	if(currentlayout < 0)
+		return;
+	LayoutData& l = CurrentLayout();
+	Vector<int> order = GetSortOrder(l.item);
+	for(int i = 0, n = cursor.GetCount(); i < n; ++i) {
+		int index = FindIndex(order, cursor[i]);
+		if(index >= 0)
+			cursor[i] = index;
+	}
+	IndexSort(l.item, order);
+	ReloadItems();
+}
+
 void LayDes::Flush()
 {
 	currentlayout = -1;
diff -ruN uppsrc/ide/LayDes/LayDes.h uppsrc/ide/LayDes/LayDes.h
--- uppsrc/ide/LayDes/LayDes.h	2013-05-25 23:14:35 +0400
+++ uppsrc/ide/LayDes/LayDes.h	2013-08-13 08:33:12 +0400
@@ -198,6 +198,20 @@
 	LayoutItem()                      { csize.cx = -1; hide = false; charset = CHARSET_UNICODE; }
 };
 
+inline bool operator<(const Ctrl::LogPos& a, const Ctrl::LogPos& b)
+{
+	if(a.y.GetA() < b.y.GetA())
+		return true;
+	if(a.y.GetA() == b.y.GetA())
+		return a.x.GetA() < b.x.GetA();
+	return false;
+}
+
+inline bool operator<(const LayoutItem& a, const LayoutItem& b)
+{
+	return a.pos < b.pos;
+}
+
 Image GetTypeIcon(const String& type, int cx, int cy, int i, Color bg);
 
 Array<LayoutItem> ReadItems(CParser& p, byte charset);
@@ -384,6 +398,7 @@
 	void        Duplicate();
 	void        MoveUp();
 	void        MoveDown();
+	void        SortItems();
 	void        SelectAll();
 
 	void        Matrix();
diff -ruN uppsrc/ide/LayDes/laywin.cpp uppsrc/ide/LayDes/laywin.cpp
--- uppsrc/ide/LayDes/laywin.cpp	2012-09-21 20:56:42 +0400
+++ uppsrc/ide/LayDes/laywin.cpp	2013-08-13 08:38:03 +0400
@@ -48,6 +48,8 @@
 	bool iscursor = currentlayout >= 0 && cursor.GetCount();
 	bar.Add(iscursor, AK_MOVEUP, LayImg::MoveUp(), THISBACK(MoveUp));
 	bar.Add(iscursor, AK_MOVEDOWN, LayImg::MoveDown(), THISBACK(MoveDown));
+	bar.Separator();
+	bar.Add(item.GetCount(), "Sort by position", THISBACK(SortItems));
 }
 
 void LayDes::AlignBar(Bar& bar)
